import { Subject } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IActivatedRouteInjected() { }
if (false) {
    /** @type {?} */
    IActivatedRouteInjected.prototype.route;
}
/**
 * @template T
 * @param {?=} dataKey
 * @param {?=} routeKey
 * @param {?=} ctr
 * @return {?}
 */
function FromRouteData(dataKey = null, routeKey = 'route', ctr = null) {
    return (/**
     * @param {?} target
     * @param {?} propertyName
     * @return {?}
     */
    (target, propertyName) => {
        if (dataKey == null) {
            dataKey = propertyName;
        }
        Object.defineProperty(target, propertyName, {
            configurable: true,
            /**
             * @return {?}
             */
            get() {
                /** @type {?} */
                const route = (/** @type {?} */ (this[routeKey]));
                if (route == null) {
                    console.error(`Property ${routeKey} is not "ActivatedRoute". Maybe you forgot to inject it`);
                }
                /** @type {?} */
                const data = route.snapshot.data;
                if (data != null && dataKey in data) {
                    if (ctr != null) {
                        return new ctr(data[dataKey]);
                    }
                    else {
                        return data[dataKey];
                    }
                }
                else {
                    return null;
                }
            },
            /**
             * @return {?}
             */
            set() {
                throw new Error('Property is readonly');
            }
        });
    });
}
/**
 * @template T
 * @param {?=} property
 * @param {?=} routeKey
 * @param {?=} ctr
 * @return {?}
 */
function MapRouteParams(property = null, routeKey = 'route', ctr = null) {
    return MapParams((/**
     * @param {?} route
     * @return {?}
     */
    route => route.snapshot.paramMap), property, routeKey, ctr);
}
/**
 * @template T
 * @param {?=} property
 * @param {?=} routeKey
 * @param {?=} ctr
 * @return {?}
 */
function MapQueryParams(property = null, routeKey = 'route', ctr = null) {
    return MapParams((/**
     * @param {?} route
     * @return {?}
     */
    route => route.snapshot.queryParamMap), property, routeKey, ctr);
}
/**
 * @template T
 * @param {?} getParamMap
 * @param {?=} property
 * @param {?=} routeKey
 * @param {?=} ctr
 * @return {?}
 */
function MapParams(getParamMap, property = null, routeKey = 'route', ctr = null) {
    return (/**
     * @param {?} target
     * @param {?} propertyName
     * @return {?}
     */
    (target, propertyName) => {
        Object.defineProperty(target, propertyName, {
            configurable: true,
            /**
             * @return {?}
             */
            get() {
                /** @type {?} */
                const route = (/** @type {?} */ (this[routeKey]));
                if (route == null) {
                    console.error(`Property ${routeKey} is not "ActivatedRoute". Maybe you forgot to inject it`);
                }
                /** @type {?} */
                const paramMap = getParamMap(route);
                if (paramMap != null) {
                    if (property == null) {
                        /** @type {?} */
                        const obj = paramMap.keys.reduce((/**
                         * @param {?} prev
                         * @param {?} key
                         * @return {?}
                         */
                        (prev, key) => {
                            return Object.assign({}, prev, { [key]: paramMap.get(key) });
                        }), {});
                        if (ctr == null) {
                            return obj;
                        }
                        else if (ctr === 'Array') {
                            throw new Error('Field "property" should be defined to take array from params');
                        }
                        else {
                            return new ctr(obj);
                        }
                    }
                    if (!paramMap.has(property) == null) {
                        return null;
                    }
                    /** @type {?} */
                    const value = paramMap.get(property);
                    if (ctr == null) {
                        return value;
                    }
                    else if (ctr === 'Array') {
                        return JSON.parse(`[${value}]`);
                    }
                    else {
                        return new ctr((/** @type {?} */ (value)));
                    }
                }
            },
            /**
             * @return {?}
             */
            set() {
                throw new Error('Property is readonly');
            }
        });
    });
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const mapObjectToAttributes = (/**
 * @param {?} obj
 * @return {?}
 */
(obj) => {
    /** @type {?} */
    const attributes = Object.keys(obj).map((/**
     * @param {?} attr
     * @return {?}
     */
    attr => `${attr}="${obj[attr]}"`));
    return attributes.join(' ');
});
const ɵ0 = mapObjectToAttributes;
/** @type {?} */
const mapObjectToStyles = (/**
 * @param {?} obj
 * @return {?}
 */
(obj) => {
    /** @type {?} */
    const styles = Object.keys(obj).map((/**
     * @param {?} style
     * @return {?}
     */
    style => `${style}: ${obj[style]}`));
    return `style="${styles.join('; ')}"`;
});
const ɵ1 = mapObjectToStyles;
/** @type {?} */
const build = (/**
 * @param {?} template
 * @param {?=} styles
 * @param {?=} attrs
 * @param {?=} classes
 * @return {?}
 */
(template, styles = {}, attrs = {}, classes = []) => `<div class="${classes.join(' ')}" ${mapObjectToStyles(styles)} ${mapObjectToAttributes(attrs)}>${template}</div>`);
const ɵ2 = build;
/**
 * @record
 */
function IFlexParam() { }
if (false) {
    /** @type {?|undefined} */
    IFlexParam.prototype.flex;
    /** @type {?|undefined} */
    IFlexParam.prototype.direction;
    /** @type {?|undefined} */
    IFlexParam.prototype.alignment;
    /** @type {?|undefined} */
    IFlexParam.prototype.justification;
    /** @type {?|undefined} */
    IFlexParam.prototype.fix;
}
class Wrapper {
    /**
     * @param {?} _template
     */
    constructor(_template) {
        this._template = _template;
        this._classes = [];
        this._flexDefaults = { flex: true, alignment: 'stretch', justification: 'flex-start', direction: 'column', fix: true };
        this.withStyles = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} styles
         * @return {THIS}
         */
        (styles) => {
            this._stylesObj = Object.assign({}, this._stylesObj, styles);
            return this;
        });
        this.withAttrs = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} attrs
         * @return {THIS}
         */
        (attrs) => {
            this._attrsObj = Object.assign({}, this._attrsObj, attrs);
            return this;
        });
        this.withWidth = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} width
         * @return {THIS}
         */
        (width) => {
            this._stylesObj = Object.assign({}, this._stylesObj, { width });
            return this;
        });
        this.withHeight = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} height
         * @return {THIS}
         */
        (height) => {
            this._stylesObj = Object.assign({}, this._stylesObj, { height });
            return this;
        });
        this.withMaxWidth = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} width
         * @return {THIS}
         */
        (width) => {
            this._stylesObj = Object.assign({}, this._stylesObj, { 'max-width': width });
            return this;
        });
        this.withMaxHeight = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} height
         * @return {THIS}
         */
        (height) => {
            this._stylesObj = Object.assign({}, this._stylesObj, { 'max-height': height });
            return this;
        });
        this.withFlex = (/**
         * @template THIS
         * @this {THIS}
         * @param {?=} params
         * @return {THIS}
         */
        (params = this._flexDefaults) => {
            this._attrsObj = Object.assign({}, this._attrsObj, this._flexDefaults, params);
            return this;
        });
    }
    /**
     * @template THIS
     * @this {THIS}
     * @param {?} className
     * @return {THIS}
     */
    withClass(className) {
        (/** @type {?} */ (this))._classes.push(className);
        return (/** @type {?} */ (this));
    }
    /**
     * @return {?}
     */
    build() {
        return build(this._template, this._stylesObj, this._attrsObj, this._classes);
    }
}
if (false) {
    /**
     * @type {?}
     * @private
     */
    Wrapper.prototype._stylesObj;
    /**
     * @type {?}
     * @private
     */
    Wrapper.prototype._attrsObj;
    /**
     * @type {?}
     * @private
     */
    Wrapper.prototype._classes;
    /**
     * @type {?}
     * @private
     */
    Wrapper.prototype._flexDefaults;
    /** @type {?} */
    Wrapper.prototype.withStyles;
    /** @type {?} */
    Wrapper.prototype.withAttrs;
    /** @type {?} */
    Wrapper.prototype.withWidth;
    /** @type {?} */
    Wrapper.prototype.withHeight;
    /** @type {?} */
    Wrapper.prototype.withMaxWidth;
    /** @type {?} */
    Wrapper.prototype.withMaxHeight;
    /** @type {?} */
    Wrapper.prototype.withFlex;
    /**
     * @type {?}
     * @private
     */
    Wrapper.prototype._template;
}
/** @type {?} */
const wrapper = (/**
 * @param {?} template
 * @return {?}
 */
(template) => new Wrapper(template));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class FlexComponent {
    constructor() {
        this._classes = "component";
        this.destroySubject = new Subject();
        this.destroy = this.destroySubject.asObservable();
        this.flex = true;
        this.fix = true;
        this.alignment = "stretch";
        this.justification = "flex-start";
        this.direction = "column";
        this.wrap = "nowrap";
        this.additionClasses = [];
    }
    /**
     * @return {?}
     */
    get classes() {
        return this._classes;
    }
    /**
     * @param {?} v
     * @return {?}
     */
    set classes(v) {
        this._classes = `component ${v} ${this.additionClasses.join(" ")}`;
    }
    // tslint:disable-next-line: use-life-cycle-interface
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.destroySubject.next();
        this.destroySubject.complete();
        if (FlexComponent.LOGS === "verbose") {
            console.log("FlexComponent destroyed", this.destroySubject);
        }
    }
}
FlexComponent.LOGS = "verbose";
if (false) {
    /** @type {?} */
    FlexComponent.LOGS;
    /** @type {?} */
    FlexComponent.prototype.flex;
    /** @type {?} */
    FlexComponent.prototype.alignment;
    /** @type {?} */
    FlexComponent.prototype.selfAlignment;
    /** @type {?} */
    FlexComponent.prototype.justification;
    /** @type {?} */
    FlexComponent.prototype.direction;
    /** @type {?} */
    FlexComponent.prototype.fix;
    /** @type {?} */
    FlexComponent.prototype.wrap;
    /** @type {?} */
    FlexComponent.prototype.additionClasses;
    /**
     * @type {?}
     * @private
     */
    FlexComponent.prototype._classes;
    /**
     * @type {?}
     * @private
     */
    FlexComponent.prototype.destroySubject;
    /**
     * @type {?}
     * @protected
     */
    FlexComponent.prototype.destroy;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
if (!window[`#flex-component.version`]) {
    window["#flex-component.version"] = "2.3.3";
}
/** @type {?} */
const PACKAGE_VERSION = "2.3.1";

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FlexComponent, FromRouteData, MapParams, MapQueryParams, MapRouteParams, PACKAGE_VERSION, Wrapper, wrapper };
//# sourceMappingURL=dev-stream-angular-utils.js.map
