import { __assign } from 'tslib';
import { Subject } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IActivatedRouteInjected() { }
if (false) {
    /** @type {?} */
    IActivatedRouteInjected.prototype.route;
}
/**
 * @template T
 * @param {?=} dataKey
 * @param {?=} routeKey
 * @param {?=} ctr
 * @return {?}
 */
function FromRouteData(dataKey, routeKey, ctr) {
    if (dataKey === void 0) { dataKey = null; }
    if (routeKey === void 0) { routeKey = 'route'; }
    if (ctr === void 0) { ctr = null; }
    return (/**
     * @param {?} target
     * @param {?} propertyName
     * @return {?}
     */
    function (target, propertyName) {
        if (dataKey == null) {
            dataKey = propertyName;
        }
        Object.defineProperty(target, propertyName, {
            configurable: true,
            get: /**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var route = (/** @type {?} */ (this[routeKey]));
                if (route == null) {
                    console.error("Property " + routeKey + " is not \"ActivatedRoute\". Maybe you forgot to inject it");
                }
                /** @type {?} */
                var data = route.snapshot.data;
                if (data != null && dataKey in data) {
                    if (ctr != null) {
                        return new ctr(data[dataKey]);
                    }
                    else {
                        return data[dataKey];
                    }
                }
                else {
                    return null;
                }
            },
            set: /**
             * @return {?}
             */
            function () {
                throw new Error('Property is readonly');
            }
        });
    });
}
/**
 * @template T
 * @param {?=} property
 * @param {?=} routeKey
 * @param {?=} ctr
 * @return {?}
 */
function MapRouteParams(property, routeKey, ctr) {
    if (property === void 0) { property = null; }
    if (routeKey === void 0) { routeKey = 'route'; }
    if (ctr === void 0) { ctr = null; }
    return MapParams((/**
     * @param {?} route
     * @return {?}
     */
    function (route) { return route.snapshot.paramMap; }), property, routeKey, ctr);
}
/**
 * @template T
 * @param {?=} property
 * @param {?=} routeKey
 * @param {?=} ctr
 * @return {?}
 */
function MapQueryParams(property, routeKey, ctr) {
    if (property === void 0) { property = null; }
    if (routeKey === void 0) { routeKey = 'route'; }
    if (ctr === void 0) { ctr = null; }
    return MapParams((/**
     * @param {?} route
     * @return {?}
     */
    function (route) { return route.snapshot.queryParamMap; }), property, routeKey, ctr);
}
/**
 * @template T
 * @param {?} getParamMap
 * @param {?=} property
 * @param {?=} routeKey
 * @param {?=} ctr
 * @return {?}
 */
function MapParams(getParamMap, property, routeKey, ctr) {
    if (property === void 0) { property = null; }
    if (routeKey === void 0) { routeKey = 'route'; }
    if (ctr === void 0) { ctr = null; }
    return (/**
     * @param {?} target
     * @param {?} propertyName
     * @return {?}
     */
    function (target, propertyName) {
        Object.defineProperty(target, propertyName, {
            configurable: true,
            get: /**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var route = (/** @type {?} */ (this[routeKey]));
                if (route == null) {
                    console.error("Property " + routeKey + " is not \"ActivatedRoute\". Maybe you forgot to inject it");
                }
                /** @type {?} */
                var paramMap = getParamMap(route);
                if (paramMap != null) {
                    if (property == null) {
                        /** @type {?} */
                        var obj = paramMap.keys.reduce((/**
                         * @param {?} prev
                         * @param {?} key
                         * @return {?}
                         */
                        function (prev, key) {
                            var _a;
                            return __assign({}, prev, (_a = {}, _a[key] = paramMap.get(key), _a));
                        }), {});
                        if (ctr == null) {
                            return obj;
                        }
                        else if (ctr === 'Array') {
                            throw new Error('Field "property" should be defined to take array from params');
                        }
                        else {
                            return new ctr(obj);
                        }
                    }
                    if (!paramMap.has(property) == null) {
                        return null;
                    }
                    /** @type {?} */
                    var value = paramMap.get(property);
                    if (ctr == null) {
                        return value;
                    }
                    else if (ctr === 'Array') {
                        return JSON.parse("[" + value + "]");
                    }
                    else {
                        return new ctr((/** @type {?} */ (value)));
                    }
                }
            },
            set: /**
             * @return {?}
             */
            function () {
                throw new Error('Property is readonly');
            }
        });
    });
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var mapObjectToAttributes = (/**
 * @param {?} obj
 * @return {?}
 */
function (obj) {
    /** @type {?} */
    var attributes = Object.keys(obj).map((/**
     * @param {?} attr
     * @return {?}
     */
    function (attr) { return attr + "=\"" + obj[attr] + "\""; }));
    return attributes.join(' ');
});
var ɵ0 = mapObjectToAttributes;
/** @type {?} */
var mapObjectToStyles = (/**
 * @param {?} obj
 * @return {?}
 */
function (obj) {
    /** @type {?} */
    var styles = Object.keys(obj).map((/**
     * @param {?} style
     * @return {?}
     */
    function (style) { return style + ": " + obj[style]; }));
    return "style=\"" + styles.join('; ') + "\"";
});
var ɵ1 = mapObjectToStyles;
/** @type {?} */
var build = (/**
 * @param {?} template
 * @param {?=} styles
 * @param {?=} attrs
 * @param {?=} classes
 * @return {?}
 */
function (template, styles, attrs, classes) {
    if (styles === void 0) { styles = {}; }
    if (attrs === void 0) { attrs = {}; }
    if (classes === void 0) { classes = []; }
    return "<div class=\"" + classes.join(' ') + "\" " + mapObjectToStyles(styles) + " " + mapObjectToAttributes(attrs) + ">" + template + "</div>";
});
var ɵ2 = build;
/**
 * @record
 */
function IFlexParam() { }
if (false) {
    /** @type {?|undefined} */
    IFlexParam.prototype.flex;
    /** @type {?|undefined} */
    IFlexParam.prototype.direction;
    /** @type {?|undefined} */
    IFlexParam.prototype.alignment;
    /** @type {?|undefined} */
    IFlexParam.prototype.justification;
    /** @type {?|undefined} */
    IFlexParam.prototype.fix;
}
var Wrapper = /** @class */ (function () {
    function Wrapper(_template) {
        var _this = this;
        this._template = _template;
        this._classes = [];
        this._flexDefaults = { flex: true, alignment: 'stretch', justification: 'flex-start', direction: 'column', fix: true };
        this.withStyles = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} styles
         * @return {THIS}
         */
        function (styles) {
            _this._stylesObj = __assign({}, _this._stylesObj, styles);
            return _this;
        });
        this.withAttrs = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} attrs
         * @return {THIS}
         */
        function (attrs) {
            _this._attrsObj = __assign({}, _this._attrsObj, attrs);
            return _this;
        });
        this.withWidth = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} width
         * @return {THIS}
         */
        function (width) {
            _this._stylesObj = __assign({}, _this._stylesObj, { width: width });
            return _this;
        });
        this.withHeight = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} height
         * @return {THIS}
         */
        function (height) {
            _this._stylesObj = __assign({}, _this._stylesObj, { height: height });
            return _this;
        });
        this.withMaxWidth = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} width
         * @return {THIS}
         */
        function (width) {
            _this._stylesObj = __assign({}, _this._stylesObj, { 'max-width': width });
            return _this;
        });
        this.withMaxHeight = (/**
         * @template THIS
         * @this {THIS}
         * @param {?} height
         * @return {THIS}
         */
        function (height) {
            _this._stylesObj = __assign({}, _this._stylesObj, { 'max-height': height });
            return _this;
        });
        this.withFlex = (/**
         * @template THIS
         * @this {THIS}
         * @param {?=} params
         * @return {THIS}
         */
        function (params) {
            if (params === void 0) { params = _this._flexDefaults; }
            _this._attrsObj = __assign({}, _this._attrsObj, _this._flexDefaults, params);
            return _this;
        });
    }
    /**
     * @template THIS
     * @this {THIS}
     * @param {?} className
     * @return {THIS}
     */
    Wrapper.prototype.withClass = /**
     * @template THIS
     * @this {THIS}
     * @param {?} className
     * @return {THIS}
     */
    function (className) {
        (/** @type {?} */ (this))._classes.push(className);
        return (/** @type {?} */ (this));
    };
    /**
     * @return {?}
     */
    Wrapper.prototype.build = /**
     * @return {?}
     */
    function () {
        return build(this._template, this._stylesObj, this._attrsObj, this._classes);
    };
    return Wrapper;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    Wrapper.prototype._stylesObj;
    /**
     * @type {?}
     * @private
     */
    Wrapper.prototype._attrsObj;
    /**
     * @type {?}
     * @private
     */
    Wrapper.prototype._classes;
    /**
     * @type {?}
     * @private
     */
    Wrapper.prototype._flexDefaults;
    /** @type {?} */
    Wrapper.prototype.withStyles;
    /** @type {?} */
    Wrapper.prototype.withAttrs;
    /** @type {?} */
    Wrapper.prototype.withWidth;
    /** @type {?} */
    Wrapper.prototype.withHeight;
    /** @type {?} */
    Wrapper.prototype.withMaxWidth;
    /** @type {?} */
    Wrapper.prototype.withMaxHeight;
    /** @type {?} */
    Wrapper.prototype.withFlex;
    /**
     * @type {?}
     * @private
     */
    Wrapper.prototype._template;
}
/** @type {?} */
var wrapper = (/**
 * @param {?} template
 * @return {?}
 */
function (template) { return new Wrapper(template); });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var FlexComponent = /** @class */ (function () {
    function FlexComponent() {
        this._classes = "component";
        this.destroySubject = new Subject();
        this.destroy = this.destroySubject.asObservable();
        this.flex = true;
        this.fix = true;
        this.alignment = "stretch";
        this.justification = "flex-start";
        this.direction = "column";
        this.wrap = "nowrap";
        this.additionClasses = [];
    }
    Object.defineProperty(FlexComponent.prototype, "classes", {
        get: /**
         * @return {?}
         */
        function () {
            return this._classes;
        },
        set: /**
         * @param {?} v
         * @return {?}
         */
        function (v) {
            this._classes = "component " + v + " " + this.additionClasses.join(" ");
        },
        enumerable: true,
        configurable: true
    });
    // tslint:disable-next-line: use-life-cycle-interface
    // tslint:disable-next-line: use-life-cycle-interface
    /**
     * @return {?}
     */
    FlexComponent.prototype.ngOnDestroy = 
    // tslint:disable-next-line: use-life-cycle-interface
    /**
     * @return {?}
     */
    function () {
        this.destroySubject.next();
        this.destroySubject.complete();
        if (FlexComponent.LOGS === "verbose") {
            console.log("FlexComponent destroyed", this.destroySubject);
        }
    };
    FlexComponent.LOGS = "verbose";
    return FlexComponent;
}());
if (false) {
    /** @type {?} */
    FlexComponent.LOGS;
    /** @type {?} */
    FlexComponent.prototype.flex;
    /** @type {?} */
    FlexComponent.prototype.alignment;
    /** @type {?} */
    FlexComponent.prototype.selfAlignment;
    /** @type {?} */
    FlexComponent.prototype.justification;
    /** @type {?} */
    FlexComponent.prototype.direction;
    /** @type {?} */
    FlexComponent.prototype.fix;
    /** @type {?} */
    FlexComponent.prototype.wrap;
    /** @type {?} */
    FlexComponent.prototype.additionClasses;
    /**
     * @type {?}
     * @private
     */
    FlexComponent.prototype._classes;
    /**
     * @type {?}
     * @private
     */
    FlexComponent.prototype.destroySubject;
    /**
     * @type {?}
     * @protected
     */
    FlexComponent.prototype.destroy;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
if (!window["#flex-component.version"]) {
    window["#flex-component.version"] = "2.3.3";
}
/** @type {?} */
var PACKAGE_VERSION = "2.3.1";

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FlexComponent, FromRouteData, MapParams, MapQueryParams, MapRouteParams, PACKAGE_VERSION, Wrapper, wrapper };
//# sourceMappingURL=dev-stream-angular-utils.js.map
