import { OnDestroy } from "@angular/core";
export declare type Alignment = "flex-start" | "flex-end" | "center" | "stretch";
export declare type Justification = "flex-start" | "flex-end" | "center" | "space-around" | "space-between";
export declare type Direction = "row" | "row-reverse" | "column" | "column-reverse";
export declare type FlexWrap = "nowrap" | "wrap" | "wrap-reverse";
export declare abstract class FlexComponent implements OnDestroy {
    static LOGS: "verbose" | "mute";
    flex: boolean;
    alignment: Alignment;
    selfAlignment: Alignment;
    justification: Justification;
    direction: Direction;
    fix: boolean;
    wrap: FlexWrap;
    additionClasses: string[];
    private _classes;
    classes: string;
    private destroySubject;
    protected destroy: import("rxjs").Observable<{}>;
    constructor();
    ngOnDestroy(): void;
}
